(* -------------------------------------------------------------------- *)
(*									*)
(*		Test6.ml						*)
(*									*)
(* -------------------------------------------------------------------- *)

(* -------------------------------------------------------------------- *)
(*	Type Declarations						*)
(* -------------------------------------------------------------------- *)

dec_elab "type 0 T1 is Int";
by elab_tac;

dec_elab "type 0 T1 is {{p1 = Int}}";
by elab_tac;

dec_elab "type 0 T1 is <Int> List -ty-> Bool";
by elab_tac;

dec_elab "type <'a, 0> T1 is <'a> List";
by elab_tac;

dec_elab "type <'a, 'b, 0> T1 is 'a -ty-> 'b";
by elab_tac;

dec_elab "type <'a, 'b, 0> T1 is 'a <*> 'b";
by elab_tac;

dec_elab "type 0 T1 is Bool; val var x = con true : <> T1";
by elab_tac;

(* -------------------------------------------------------------------- *)
(*	Datatype Declarations						*)
(* -------------------------------------------------------------------- *)

dec_elab "datatype 0 T1 =  con c1";
by elab_tac;

dec_elab "datatype 0 T1 = con c1 | con c2";
by elab_tac;

dec_elab "datatype 0 T1 = con c1 of Int";
by elab_tac;

dec_elab "datatype 0 T1 =  con c1 of Int | con c2 | con c3";
by elab_tac;

dec_elab "datatype 0 T1 =  con c2 of 0 T1";  (* naturals *)

dec_elab "datatype 0 T1 =  con c1 | con c2 of <> T1"; 
                       (* natural numbers - note the syntax for empty lists! *)
by elab_tac;


dec_elab "datatype 0 T1 =  con c1; val var x1 = con c1";
by elab_tac;

dec_elab   "datatype 0 T1 = con c1 | con c2;   \
            \ val var f1 = fn con c1 => con true | _ => con false;  \
            \ val var x1 = var f1 ` con c1";
by elab_tac;


(* -------------------------------------------------------------------- *)
(*	Abstype Declarations						*)
(* -------------------------------------------------------------------- *)

(* Life is too short to worry about these *)


