(* -------------------------------------------------------------*)
(*								*)
(*		elab_atexp.thy:					*)
(*								*)
(* ------------------------------------------------------------ *)

elab_atexp = elab_obj +

rules

Scon	"(int = t) <-> C |- scon n ~> t"	(* Rule 1 *)

Var_	"(EX T U SE TE VE EE s. C = <T, U, SE, TE, VE, EE> & \
\          VE ` <Var, x> = s & s [>] t) <-> C |- var x ~> t"  (* Rule 2 *)

Con     "(EX T U SE TE VE EE s. C = <T, U, SE, TE, VE, EE> &  \
\          VE ` <Con, c> = s & s [>] t) <-> C |- con  c ~> t"  (* Rule 3 *)

ExCon   "(EX T U SE TE VE EE s. C = <T, U, SE, TE, VE, EE> & \
\          VE ` <ExCon, e> = t) <->  C |- excon  e ~> t" (* Rule 4 *)
    
Empty_Record	  
        "<RecType, 0> = t <-> C |- {{}} ~> t" (* Rule 5a *)
     
Record	"(EX rectype. C |- exprow ~> rectype [ExpRow] & \
\          <RecType, rectype> = t) <->   C |- {{exprow}} ~> t"  (* Rule 5b *)

Let      "(EX E C'. C ||- dec ~> E & C ## <0, 0, E> = C' & \
\        C' |- exp ~> t) <-> C |-  let dec in exp end ~>  t "	(* Rule 6 *)

Bracket	"C |- exp ~> t <-> C |- (- exp -) ~> t"

end
