(* -------------------------------------------------------------*)
(*								*)
(*		elab_pat.thy:					*)
(*								*)
(* ------------------------------------------------------------ *)

elab_pat = elab_patrow +

rules

Con_Val_Pat     " (EX T U SE TE VE EE s t'. C = <T, U, SE, TE, VE, EE> & \
\                 VE`<Con, c> = s & s [>] <FunType, t', t> &  \
\                 C ||- pat ~> (VE', t') [Pat] ) <->  \
\                 C ||- con c ` pat ~> (VE', t) [Pat]" (* Rule 43 *)

ExCon_Val_Pat   "(EX T U SE TE VE EE s t'. C = <T, U, SE, TE, VE, EE> & \
\                 VE`<ExCon, e> = s &  s [>] <FunType, t, exn> &   \
\                 C ||- pat ~> (VE', t) [Pat] ) <->  \
\                 C ||- excon e ` pat ~> (VE', exn) [Pat]" 	(* Rule 44 *)

Typed_Pat       "(C ||- pat ~> (VE, t) [Pat] & C |- ty ~> t [Ty]) <-> \
\                C ||- pat : ty ~> (VE, t) [Pat]" (* Rule 45 *)

Layered_Pat     "(C ||- var x ~> (VE, t) [Pat] &  \
\                C ||- pat ~> (VE', t) [Pat] & VE @@ VE' = VE'') <-> \
\                C ||- var x as pat ~> (VE'', t) [Pat]" (* Rule 46a *)

Typed_Layered_Pat  "(C ||- var x ~> (VE, t) [Pat] &  \
\                C |- ty ~> t [Ty] &   C ||- pat ~> (VE', t) [Pat] & \
\               VE @@ VE' = VE'') <->  \
\               C ||- var x : ty as pat ~> (VE'', t) [Pat]"(* Rule 46b *) 

end
