(* -------------------------------------------------------------------- *)
(*	Test2.ML							*)
(*	Tests of ZF-based ML verifier					*)
(* -------------------------------------------------------------------- *)

(* -------------------------------------------------------------------- *)
(*									*)
(*		Examples of Derived Forms				*)
(*									*)
(* -------------------------------------------------------------------- *)


exp_eval "(-var times, var minus-)";
by eval_tac;

exp_eval "if con true then scon m else scon n";
by eval_tac;

exp_eval "if con false then scon m else scon n";
by eval_tac;

exp_eval "if zero scon 0 then var plus else var times";  
by eval_tac;

exp_eval "if not zero scon 0  then var plus else var times";
by eval_tac;

dec_eval "val (-var x1, var x2-) = (-scon m, scon n-)";
by eval_tac;


