(* -------------------------------------------------------------*)
(*								*)
(*		elab_conbind.thy:				*)
(*								*)
(* ------------------------------------------------------------ *)

elab_conbind = elab_datbind +

rules

ConBind1   "{<<Con, c>, All, 0, t>} = CE <-> C, t ||- con c ~> CE [ConBind]"  
                                             (* Rule 30a *)
ConBind2   "(EX t'.  C |- ty ~> t' [Ty] &  \
\          {<<Con, c>, All, 0, FunType, t', t>} = CE) <-> \
\          C, t ||- con c of ty ~> CE [ConBind]" (* Rule 30b *)

ConBind3   "(EX CE. C, t ||- conbind ~> CE [ConBind] &   \
\           {<<Con, c>, All, 0, t>} @@ CE = CE') <->  \
\           C, t ||- con c | conbind ~> CE' [ConBind]"  (* Rule 30c *)

ConBind4   "(EX CE. C, t ||- conbind ~> CE [ConBind] &  \
\           C |- ty ~> t' [Ty] &  \
\          {<<Con, c>, All, 0, FunType, t', t>} @@ CE = CE') <->\
\          C, t ||- con c of ty | conbind ~> CE' [ConBind]"	(* Rule 30d *)

end
