(* -------------------------------------------------------------*)
(*								*)
(*		elab_exbind.thy:				*)
(*								*)
(* ------------------------------------------------------------ *)

elab_exbind = elab_conbind +

rules

ExBind1    "{<<ExCon, e>, All, 0, exn>} = EE <-> \
\           C ||- excon e ~> EE [ExBind]"  (* Rule 31a *)

ExBind2    "(EX t.  C |- ty ~> t [Ty] & \
\           {<<ExCon, e>, All, 0, FunType, t, exn>} = EE) <->  \
\           C ||- excon e of ty ~> EE [ExBind]"  (* Rule 31b *)

ExBind3    "(EX EE. C ||- exconbind ~> EE [ExBind] &  \
\           {<<ExCon, e>, All, 0, exn>} @@ EE = EE') <->  \
\          C ||- excon e and exconbind ~> EE' [ExBind]"  (* Rule 31c *)

ExBind4    "(EX EE. C ||- exconbind ~> EE [ExBind] &   \
\          C |- ty ~> t [Ty] &  \
\          {<<ExCon, e>, All, 0, FunType, t, exn>} @@ EE = EE') <->  \
\          C ||- excon e and exconbind ~> EE' [ExBind]" (* Rule 31d *)

ExBind5    "(EX T U SE TE VE EE. C = <T, U, SE, TE, VE, EE> &   \
\          VE ` <ExCon, e'> = t  &  {<<ExCon, e>, All, 0, t>} = EE') <-> \
\          C ||- excon e is e' ~> EE' [ExBind]" (* Rule 32a *)

ExBind6    "(EX T U SE TE VE EE. C = <T, U, SE, TE, VE, EE> &   \
\          C ||- exbind ~> EE [ExBind] &  VE ` <ExCon, e'> = t &  \
\          {<<ExCon, e>, All, 0, t>} @@ EE = EE')  <-> \
\          C ||- excon e is e' and exbind ~> EE' [ExBind]"(* Rule 32b *)

end
