(* -------------------------------------------------------------*)
(*								*)
(*		eval_atexp.thy:					*)
(*								*)
(* ------------------------------------------------------------ *)

eval_atexp = eval_obj +

rules

					(* Rule 103  *)
Scon	  "<Val, SVal, n> = v' <-> E |- scon n ~> v'" 
					(* Rule 104 *)
Var_	  "(EX SE VE EE. E = <SE, VE, EE> &  VE`<Var,x> = v & <Val, v> = v') \
\          <-> E |-  var x ~> v'"  
					(* Rule 105 *)
Con	  "<Val, Con, c> = v' <-> E |- con  c ~> v'"
					(* Rule 106 *)
ExCon	  "(EX SE VE EE. E = <SE, VE, EE> & EE`<ExCon,e> = en & \
\                <Val, ExVal, ExName, en> = v')  \
\            <-> E |-  excon e ~> v'"  
				(* Rule 107a *)
Empty_Record	 
          " <Val, Record, 0> = v' <-> E |- {{}} ~> v'"
					(* Rule 107b *)
Record	  "(EX record. E |- exprow ~> <Val, record> [ExpRow] & \
\          <Val, Record, record> = v') <->  E |- {{exprow}} ~> v'"
					(* Rule 108  *)
Let        "(EX E' E''. E ||- dec ~> E' & E # E' = E'' & \
\            E'' |- exp ~> v') <-> \
\            E |- let dec in exp end ~> v'"
				(* Rule 109 *)
Bracket	"E |- exp ~> v' <-> E |- (- exp -) ~> v'"


end
