(* -------------------------------------------------------------*)
(*								*)
(*			eval_dec.thy:				*)
(*								*)
(* ------------------------------------------------------------ *)

eval_dec = eval_mrule +

rules

					(* Rule 129 *)
Val	"(EX VE. E ||- valbind ~> VE [ValBind] & <0, VE, 0> = E') \
\         <-> E ||- val valbind ~> E'"
				(* Rule 130 *)
Exception	"(EX EE. E ||- exbind ~> EE [ExBind] & <0, 0, EE> = E') \	\         <-> E ||- exception exbind ~> E'"
					(* Rule 131 *)
Local	" (EX E1 E'. E ||- dec1 ~> E1  & \
\          E # E1 = E' & E' ||- dec2 ~> E2)  <-> \
\          E ||- local dec1 in dec2 end ~> E2"
						 (* Rule 132 omitted *)
					(* Rule 133 *)
Nothing	"<0, 0, 0> = E' <-> E ||- nothing ~> E'"
					(* Rule 134a *)
Comp1	"(EX E1 E1' E' E2. E ||- dec1 ~> E1 &  \
\         E # E1 = E1' & E1' ||- dec2 ~> E2 & E1 # E2 = E3) <-> \
\         E ||- dec1  dec2 ~> E3"
					(* Rule 134b *)
Comp2	"(EX E1 E1' E' E2. E ||- dec1 ~> E1 &  \
\         E # E1 = E1' & E1' ||- dec2 ~> E2 & E1 # E2 = E3) <-> \
\         E ||- dec1 ; dec2 ~> E3"

end
